Bug 928390 - Python SSLSocket.getpeercert() incorrectly returns an empty Subject Alternative Name from peer certificate.
Summary: Python SSLSocket.getpeercert() incorrectly returns an empty Subject Alternati...
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: python
Version: 6.4
Hardware: Unspecified
OS: Unspecified
high
high
Target Milestone: rc
: ---
Assignee: Matej Stuchlik
QA Contact: Jan Kepler
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2013-03-27 14:42 UTC by Ken Giusti
Modified: 2018-12-03 18:33 UTC (History)
7 users (show)

Fixed In Version: python-2.6.6-47.el6
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2013-11-21 09:14:08 UTC
Target Upstream Version:


Attachments (Terms of Use)
Fix backported from 2.7 (471 bytes, patch)
2013-06-11 12:25 UTC, Matej Stuchlik
no flags Details | Diff


Links
System ID Priority Status Summary Last Updated
Python 13034 None None None Never
Red Hat Bugzilla 885173 None None None Never
Red Hat Product Errata RHSA-2013:1582 normal SHIPPED_LIVE Moderate: python security, bug fix, and enhancement update 2013-11-20 21:39:43 UTC

Internal Links: 885173

Description Ken Giusti 2013-03-27 14:42:29 UTC
Description of problem:

As documented, SSLSocket.getpeercert() should provide access to the Subject Alternate Name field from the peer's certificate.  A bug in python will result in the Subject Alternate Name field to not be available to the application.

This could cause a false authentication failure if the application performs certificate hostname checking.

Version-Release number of selected component (if applicable):

python-2.6.6-36

How reproducible:

100%

Steps to Reproduce:
1. python client connects to SSL server which has a SAN in its certificate
2. Have python access the certificate via getpeercert()
3. The returned map should have an entry for 'subjectAltName'
  
Actual results:

No entry for 'subjectAltName'

Expected results:

The map contains a 'subjectAltName' entry with a value that matches the SAN from the peer certificate.

Additional info:

The fix for this bug is straightforward, and has been fixed upstream in 2.7.3.  See http://bugs.python.org/issue13034

Comment 2 Bohuslav "Slavek" Kabrda 2013-05-22 12:44:38 UTC
This patch will work ok with RHEL 6 Python 2.6.

Comment 3 Matej Stuchlik 2013-06-11 12:25:46 UTC
Created attachment 759603 [details]
Fix backported from 2.7

Comment 11 errata-xmlrpc 2013-11-21 09:14:08 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2013-1582.html


Note You need to log in before you can comment on or make changes to this bug.